#include <iostream>
using namespace std;
#include<cmath>



class quadraticPolynomial
{
    public:
       double a;
	   double b;
	   double c;
	   quadraticPolynomial() {a=b=c=0;};
	   quadraticPolynomial(double aValue, double bValue,double cValue) 
	   {
			a=aValue;b=bValue;c=cValue;
		}
	   double evaluate(double w) {return a*w*w+b*w+c;}
	   void print() {cout<<a<<"*x^2 + "<<b<<"*x + "<<c<<endl;}
       int realRoots(double & x1,double & x2) 
	   {
		  if(a==0 && b==0) { 
			  if(c==0) return 999;
			  else return 0;
		  }
		  if(a==0) {x1 = -c/b;; return 1;} 
		  double Delta = b*b-4*a*c;
		  if(Delta<0)  return 0;
		  x1 = (-b+sqrt(Delta))/(2*a);
	      x2 = (-b-sqrt(Delta))/(2*a);
		  return 2;
	   }
	   bool isSquare() 
	   {
		   if(a<=0) return false; // corrected on Jan 31(previous version a==0)
           double Delta = b*b-4*a*c;
		   if(Delta ==0) return true;
		   else return false;
	   }
       quadraticPolynomial derivative()
	   {
		      quadraticPolynomial D(0,2*a,b);
			  return D;
	   }


};

		        
quadraticPolynomial sum(const quadraticPolynomial & P, const quadraticPolynomial & Q)
{
			    quadraticPolynomial R;
                R.a = P.a+Q.a;
				R.b = P.b+Q.b;
		        R.c = P.c+Q.c;
				return R;	   
}



int main() 
{
	quadraticPolynomial p(1,5,3),q(1,2,1), r;
	cout<<"p: ";p.print();
	cout<<"q: ";q.print();
	cout<<"r: ";r.print();
	cout<<"p(2)="<<p.evaluate(2)<<endl;
	r = sum(p,q);
	cout<<"p+q: ";r.print();
	r = p.derivative();
    cout<<"derivative r of p: ";r.print();
	double x1,x2;
    if(p.realRoots(x1,x2)==2) cout<<"roots of p : "<<x1<<","<<x2<<endl;
	if(q.realRoots(x1,x2)==2) cout<<"roots of q : "<<x1<<","<<x2<<endl;
	if(r.realRoots(x1,x2)==1) cout<<"root of r : "<<x1<<endl;
	if(q.isSquare())  cout<<"q is a square";
	else cout<<"q is not a square";
    cout<<endl;
	if(p.isSquare())  cout<<"p is a square";
	else cout<<"p is not a square";
    cout<<endl;

	return 0;
}